--- dovecot-1.0.13/src/plugins/zlib/zlib-plugin.c.orig	2008-03-28 16:34:01.818042000 +0000
+++ dovecot-1.0.13/src/plugins/zlib/zlib-plugin.c	2008-03-28 16:35:08.841964000 +0000
@@ -39,6 +39,17 @@
 static unsigned int zlib_storage_module_id = 0;
 static bool zlib_storage_module_id_set = FALSE;
 
+/* Peek in to the mail and see if it looks like it's compressed (it has the
+correct 2 byte zlib header */
+static int is_compressed(struct istream * mail)
+{
+  const unsigned char * zheader = NULL;
+  size_t header_size = 2;
+  if (!i_stream_read_data(mail, &zheader, &header_size, header_size)) return 0;
+  i_stream_seek(mail, -2);
+  return header_size >= 2 && zheader && zheader[0] == 31 && zheader[1] == 139;
+}
+
 static struct istream *
 zlib_maildir_get_stream(struct mail *_mail, struct message_size *hdr_size,
 			struct message_size *body_size)
@@ -48,8 +59,6 @@
 	struct index_mail *imail = (struct index_mail *)mail;
 	struct zlib_mail *zmail = ZLIB_CONTEXT(mail);
 	struct istream *input;
-	const char *fname, *p;
-        enum maildir_uidlist_rec_flag flags;
 	int fd;
 
 	if (imail->data.stream != NULL)
@@ -60,10 +69,7 @@
 		return NULL;
 	i_assert(input == imail->data.stream);
 
-	fname = maildir_uidlist_lookup(mbox->uidlist, _mail->uid, &flags);
-	p = fname == NULL ? NULL : strstr(fname, ":2,");
-	if (p != NULL && strchr(p + 3, 'Z') != NULL) {
-		/* has a Z flag - it's compressed */
+  if (is_compressed(imail->data.stream)){
 		fd = dup(i_stream_get_fd(imail->data.stream));
 		if (fd == -1)
 			i_error("zlib plugin: dup() failed: %m");
